/************************************************************************/
/*                                                                      */
/*                      Several helpful definitions                     */
/*                                                                      */
/*              Author: Peter Dannegger                                 */
/*                                                                      */
/************************************************************************/
#ifndef _mydefs_h_
#define _mydefs_h_
#include<avr/io.h>

// Access bits like variables:
struct bits {
  uint8_t b0:1, b1:1, b2:1, b3:1, b4:1, b5:1, b6:1, b7:1;
} __attribute__((__packed__));
#define SBIT_(port,pin) ((*(volatile struct bits*)&port).b##pin)
#define	SBIT(x,y)	SBIT_(x,y)


// avoid push in main
int main( void ) __attribute__((OS_main));


// force access interrupt variables
#define INTVAR(x)    (*(volatile typeof(x)*)&(x))


// Always Inline
#define AIL(x)   static inline x __attribute__ ((always_inline)); static inline x


//			NOP
#define NOP()		__asm__ volatile("nop"::)

#endif
